### 24/05/2019. Ergasia 2, Apli Grammiki Palindromisi. 

### Solutions for Project 2 
### Course: Statistics II
### Designed by the STATISTICS GROUP 2018-19 
    SAMIS TREVEZAS (BASIC RESPONSIBLE TO BLAME FOR)
    VASILIS KATSIANOS (LORD OF THE LABS)
    CHRISTINA GIANNADAKI, KONSTANTINA KATACHANA, LEONIDAS KORDALIS (GUEST STARS)
    [Without the voluntary work of MSc students, this course would be limited to a theoretical
     presentation and an insufficient lab work. A great thanks to all the contributors, including 
     advanced undergraduate students who helped in the labs.]

### THIS CODE WITH COMMENTS FOR THE SOLUTIONS IS DISTRIBUTED ONLY FOR ACADEMIC PURPOSES
### AND CAN BE USED AND REDISTRIBUTED PARTLY ONLY FOR SUCH REASONS
### IT IS DESTINED FOR BEGINNERS IN R AND STATISTICS AND SPECIFICALLY DESIGNED
### FOR THE NEEDS OF THE STUDENTS OF THE COURSE  


### IMPORTANT NOTE: STUDY VERY WELL THE SOLUTION OF THIS PROJECT, BEFORE COMPLETING
                    THE THIRD AND LAST ONE. I HAVE PUT EXTENDED COMMENTS FOR A GOOD UNDERSTANDING
                    OF THE RESULTS. NOW, IT IS AN OPPORTUNITY TO SHOW THAT YOU HAVE ADVANCED DURING THE COURSE.

## Prokatarktika 
rm(list=ls())  
library(car)  # fortonoume ti vivliothiki pou tha xreiastoume
 
ozone = read.table(file="ozone.txt", header=T, row.names=1)
              # edo mono to file itan aparaitito
               
head(ozone)   # tail() for showing only the last lines
#attach(ozone) # apeytheias prosvasi sta onomata ton metavliton xoris prosthiki ozone$
               # emperiexei kindynous an yparxoun koina onomata me alles metavlites
## Erotima 1

T12 = ozone$T12
maxO3 = ozone$maxO3
plot(T12, maxO3)

# Parolo pou ta dedomena fainontai arketa diesparmena, diakrinoume mia grammiki tasi anodou tou max03
# kathos to T12 ayksanetai. Mia apli grammiki palindromisi sta dedomena fainetai os logiki epilogi.

## Erotima 2

reg = lm(maxO3~T12) #data=ozone

# me ti synartisi lm kanoume ti grammiki palindromisi Y~X opou Y=max03 i eksartimeni kai X=T12 i aneksartiti metavliti

## Erotima 3

reg

# Meso tis Call emfanizetai i pliroforia oti ektelesame grammiki palindromisi (meso tis lm)
# kai oi ypo eksetasi metavlites. Episis mas dinei meso ton Coefficients tis ektimiseis
# ton synteleston tis palindromisis, diladi tis statheras (beta_1:Intercept=31.415) kai autou pou antistoixei
# sto T12 (beta_2=2.701)

attributes(reg)

#> attributes(reg)
#$names
# [1] "coefficients"  "residuals"     "effects"       "rank"         
# [5] "fitted.values" "assign"        "qr"            "df.residual"  
# [9] "xlevels"       "call"          "terms"         "model"      

# Mas dinontai arketa xaraktiristika tis palindromisis pou gnorizoume apo ti theoria, p.x.,
# "coefficients" : oi syntelestes tis palindromisis hat(beta_i)
# "residuals"    : ta kataloipa/ypoloipa tis palindromisis hat(eps_i)
# "rank"         : i taksi tou pinaka sxediasmou X
# "fitted.values : oi prosarmosmenes times ton Y, diladi ta hat(Y_i)
# "df.residual   : oi vathmoi tis eleytherias n-p tis katanomis ton ypoloipon hat(eps_i) (t_{n-p})

# mporoume na exoyme prosvasi se ayta me reg[i] i me onomata, p.x. reg$coefficients
# Gia prosvasi se sygkekrimeno stoixeio reg[[i]][j]

## Erotima 4

summary(reg)

#Call:
#lm(formula = max03 ~ T12)                    # eksigisi opos prin

#Residuals:                                   
#    Min      1Q  Median      3Q     Max        
# -45.256 -15.326  -3.461  17.634  40.072 

# Ta Residuals dinoun statistika stoixeia tis deigmatikis katanomis ton kataloipon 
# (minimum, proto, deutero kai trito tetartimorio kai to maximum)
# paratiroume oti to eyros ton kataloipon einai sxetila megalo, to opoio eksigeitai apo ti sxetika
# megali diaspora ton dedomenon, kai i katanomi einai elafra metatopismeni pros tis arnitikes times, afou
# i diamesos einai arnitiki

# Coefficients:
#             Estimate Std. Error t value Pr(>|t|)    
# (Intercept)  31.4150    13.0584   2.406     0.02 *  
# T12           2.7010     0.6266   4.311 8.04e-05 ***
# ---
# Signif. codes:  0 *** 0.001 ** 0.01 * 0.05 . 0.1   1

# Gia tous syntelestes tis palindromisis:
# Stili 1: ta ektimimena beta opos paratirisame prin. Ta apotelesmata epivevaionoun tin anodiki tasi,
# me Intercept > 0 kai megali thetiki klisi (anodiki tasi) tis taksis tou 2.7
# Stili 2: oi ektimimenes typikes apokliseis ton hat(beta). Paratiroume oti oi ektimiseis aytes einai sxetika megales, to opoio eksigeitai apo
# ti sxetika megali diaspora ton dedomenon, kai to sxetika mikro arithmo dedomenon (50 paratiriseis)
# pou ayksanoun tin avevaiotita stis ektimiseis ton dyo synteleston beta.
# Stili 3: H t-value exei na kanei me tin timi tou statistikoy elegxou T_i = hat(beta_i)/hat(sd)_{hat(beta_i)}
# kato apo ti mideniki ypothesi oti b_i = 0. Paratiroume Stili 3 = Stili 1 / Stili 2, opos anamenetai apo ti theoria.
# Stili 4: Oi pithanotites aytes dinoun tis p-value, diladi tin Pr(|T| > |t|) kato apo ti mideniki ypothesi H0: b_i=0, i=1,2, me ti voitheia
# tis katanomis Student, afou T ~ t_{48}, kato apo tin H_0. Me aytes tis times mporoume na kanoume ton elegxo ypotheseon H0 vs H1 
# gia tin apodoxi i oxi tis H0 se kapoio epipedo simantikotitas. Ta apotelesmata mas deixnoun oti to Intercept kai i T12
# einai statistika simantikes se epipedo a=0.05, afou oi times tous einai mikroteres apo to a=0.05, kati to opoio odigei se
# aporipsi tis H0.
# Malista i p-value mas deixnei ti megalyteri timi epipedou simantikotitas, pou ginetai apodekti i H0. Etsi loipon ta apotelesmata ayta mas
# deixnoun oti se ola ta synithi epipeda simantikotitas (a=0.01, a=0.02, a=0.05, a=0.1) i T12 einai statistika simantiki (i H0 aporriptetai)
# Oi kodikes me ta * kai tis . mas deixnoun se poio group epipedon simantikotitas vriskomaste opos eksigeitai apo tin teleytaia grammi.
 
#Residual standard error: 20.5 on 48 degrees of freedom    # ektimoumeno typiko sfalma (sigma), prokyptei os riza tou ameroliptoy ektimiti tis diasporas
                                                           # to apotelesma einai synepes me ti megali diaspora ton dedomenon. 
s=sqrt(sum(reg[[2]]^2)/48)
s                                                          # s = 20.50376
#Multiple R-squared:  0.2791,    Adjusted R-squared:  0.2641  # to kritirio R^2 = SSR / SST = ||hat(Y)-bar(Y)||^2/||Y-bar(Y)||^2, to opoio mas
                                                           # deixnei to pososto metavlitotitas pou eksigeitai apo tis prosarmosmenes times ton Y.
                                                           # i timi tou einai mikri to opoio deixnei oti eno i T12 mas dinei simantiki pliroforia gia to maxO3
                                                           # apo moni tis den arkei gia ena ikanopoiitiko montelo. To Adjusted R^2 tha eksigithei argotera.
#F-statistic: 18.58 on 1 and 48 DF,  p-value: 8.041e-05    
                                                           # To statistiko F einai gia to F-test (tha eksigithei argotera), edo einai F=T^2 (opos kai i teleytaia p-value)

## Erotima 5

confint(reg)
               #               2.5 %   97.5 %
               # (Intercept) 5.159232 57.67071
               # T12         1.441180  3.96089

# Ta oria ton 95% diastimaton empistosynis epivevaionoun ti sxetika megali avevaiotita stis times ton synteleston tis palindromisis,
# gia tous logous pou eksigithikan parapano.

# epalitheysi ton diastimaton empistosynis apo theoria 
c = qt(0.975,df=reg$df.res)
beta1min = coef(summary(reg))[1,1]-c*coef(summary(reg))[1,2]
beta1max = coef(summary(reg))[1,1]+c*coef(summary(reg))[1,2]
beta2min = coef(summary(reg))[2,1]-c*coef(summary(reg))[2,2]
beta2max = coef(summary(reg))[2,1]+c*coef(summary(reg))[2,2]

beta1min; beta1max; beta2min; beta2max

# Tha mporouse episis na paratirisei kaneis logo tis dyikotitas ton diastimaton empistosynis me tous elegxous ypotheseon, oti efoson
# to 0 den periexetai sta diastimata empistosynis gia kanenan apo tous syntelestes, oti i antistoixes midenikes ypotheseis 
# tha apporiptontai se epipedo simantikotitas a = 0.05.

## Erotima 6

x11()
plot(T12, maxO3)
abline(reg, col="red")      # sxediazei ap'eytheias tin eytheia ton elaxiston tetragonon

T = seq(from = min(T12), to = max(T12), length.out = 500)
P = predict(reg, newdata=data.frame(T12 = T), interval="confidence", level = 0.95)
matlines(T, P[,-1], lty=2, col=c("blue","blue"))

# edo emfanizontai oi kampyles ton diastimaton empistosynis gia tis meses apokriseis poy einai hat(y) = hat(b_1) + hat(b_2)x
# I katanomi tou hat(y) mporei na vrethei, exoume idi dei endeiktika oti Var(hat(y)) = sigma^2 * {1/n + [(x-bar(x))^2/ Sxx])
# Ayto deixnei oti i diaspora kai epomenos kai i typiki apoklisi elaxistopoieitai otan vriskomaste sto kentro ton dedomenon
# kai ayksanei (symmetrika, ekaterothen tou bar(x)) oso apomakrynomaste apo to bar(x). Ayto fainetai ksekathara edo me ti voitheia ton 2 kampylon.
# Diaisthitika tha mporouse na to perimenei kaneis, an skeftei oti i pliroforia pou exoume gia ti mesi symperifora tou montelou
# konta sto kentro ton timon tis aneksartitis metavlitis einai panta perissoteri sygkritika me tis akraies times tis x,
# ara tha exoume genika mikroteri avevaiotita sto kentro kai megalyteri avevaiotita sta akra. 
# Par'ola ayta an kanete ta diastimata empistosynis gia ta dedomena tou Geyser, i kampylosi den tha einai emfanis. Skefteite giati... 

# Ta oria ayta mas ypodeiknyoun oti mporoume na eimaste 95% sigouroi oti i pragmatiki eytheia tou grammikou montelou (me ta pragmatika beta) 
# vrisketai mesa sta oria pou kathorizoun oi mple kampyles, alla gia kathe ena apo ta x memonomena (kata simeio diastimata empistosynis)
# Gia na kanoume enan elegxo aytou tou isxyrismou mporoume na kanoume tin eksis prosomoiosi. Pernoume beta =hat(beta) (kai sigma^2=hat(sigma^2)) kai epanalavoume 
# enan poly megalo arithmo peiramaton tyxis paragogis Y_i me aytes tis parametrous, tote peripou 95% ton periptoseon to simeio pou antistoixei stin 
# pragmatiki eytheia (pou edo ypothesame tin eytheia palindromisis), tha vrisketai mesa sta 95% diastimata empistosinis pou kathorizontai stis prosomoioseis
# (mporeite na ayksisete to plithos ton prosomoioseon > 10.000 i kalytera (gia logous kostous stin apothikeysi megalis diastasis pinakon) na epanalavete polles fores 
# me mikrotero arithmo prosomoioseon kai na parete to meso oro ton apotelesmaton).
# Ayto de simainei oti peripou 95% ton periptoseon oi eytheies ton elaxiston tetragonon tha vriskontai mesa sta oria pou kathorizoun oi mple kampyles gia kathe 
# ena apo ta x memonomena. Ayto fainetai apo tis prosomoioseis edo parakato an allaksete tin entolis if opos ypodeiknyetai parakato. Tha deite an epanalavete
# polles fores to peirama oti o mesos oros den sygklinei genika sto 0.95.
# Oyte simainei oti oi mple kampyles kathorizoun 95% lorida empistosynis gia tin pragmatiki eytheia. Deite parakato.  

ind=4
P0=predict(reg, newdata=data.frame(T12=T12[ind]), interval="confidence") 

num=0
B = matrix(0,10000,3)
for(i in 1:10000){
Yi= reg[[1]][1] + reg[[1]][2]*T12 + rnorm(50,0,s)
regi = lm(Yi~T12)
P = predict(regi, interval="confidence")
B[i,]=P[ind,]

#if(B[i,1]>P0[2] & B[i,1]<P0[3])  # epilogi gia antiparadeigma me tis mple kampyles
if(B[i,2]<P0[1] & B[i,3]>P0[1]) # epilogi gia epalitheysi tou diastimatos empistosynis
{
num=num+1
}
}
num/10000   # ektimisi


## Erotima 7

x11()
confidenceEllipse(reg)

rect(beta1min,beta2min,beta1max,beta2max,lty=2,lwd=2)

# To 95% elleipsoeides empistosynis mas deixnei oti yparxei megali arnitiki eksartisi (kai sysxetisi) metaksy ton ektimitrion ton antistoixon synteleston, 
# to opoio fainetai apo tin arnitiki klisi tou kyriou aksona tis elleipsis 
# kai ti megali diafora tou mikous metaksi tou kyriou kai tou deyterevonta aksona (arketa loksi kai peplatysmeni elleipsi).

# Paratiroume episis oti ta miki ton provolon tis elleipsis pano stous aksones ton x kai y, einai megalytera apo ta antistoixa miki ton 95% perithorion
# diastimaton empistosynis ton synteleston, pou fainontai apo to orthogonio empistosynis. Ara loipon, eno to elleipsoeides einai poly xrisimo kai pliroforiako
# gia tin taytoxroni ektimisi ton 2 synteleston, an kapoios to xrisimopoiouse esfalmena gia ton kathorismo diastimaton empistosynis memonomena gia tous syntelestes,
# tote vlepoume oti odigei se "syntiritika" diastimata, diladi se diastimata pou einai pio megala apo oti tha eprepe na einai gia 95% diastimata empistosynis.

# Apo tin alli pleyra, to orthogonio tis empistosynis, eno perithoria mas dinei 95% diastimata empistosynis gia tous syntelestes, apo mono tou 
# den apotelei 95% perioxi empistosynis gia ta zeygi. Paratirontas to elleipsoeides kai ti simantiki diafora emvadou metaksy tou orthogoniou kai tis elleipsis,
# sto sygkekrimeno paradeigma fainetai oti o syntelestis empistosynis tou orthogoniou tha itan megalyteros apo 0.95.

# Kapoios tha mporouse episis na paratirisei oti to orthogonio odigei se perioxi empistosynis toulaxiston 0.9.
# Ara mia sygkrisi me ayto to orthogonio den fainetai dikaii, kai tha eprepe na paroume 97.5% perithoria diastimata empistosynis  
# gia na eimaste sigouroi oti to orthogonio odigei se toulaxiston 95% perioxi empistosynis. Parola ayta, ayto tha mas odigouse telika se
# akomi megalytera orthogonia, kai ara sto sygkekrimeno paradeigma, se mia akoma pio "syntiritiki" epilogi.

## Erotima 8

source("confidenceBand.R")
confidence.band(reg)
P = predict(reg, newdata=data.frame(T12 = T), interval="confidence", level = 0.95)
matlines(T, P[,-1], lty=2, lwd=2, col=c("blue","blue"))

# Kathe zeygos synteleston (b_1, b_2) me times sto R^2 kathorizei mia dynati eytheia palindromisis y = b_1 + b_2 x kai antistrofa. 
# Ara an (hat(beta_1), hat(beta_2)) einai oi ektimimenoi syntelestes kai as poume E to 95% elleipsoeides empistosynis, tote ayto kathorizei 
# mia ektimimeni eytheia palindromisis kai antistoixa mia 95% lorida empistosynis as poume B, pou prokyptei an sxediasoume oles tis dynates eytheies pou tha exoun 
#  ta (b_1, b_2) mesa sto synolo E. Ta oria aytis tis loridas antiprosopevontai apo tis kokkines kampyles.

# Sygkrinontas me tis kokkines me tis mple kampyles paratiroume oi dyo lorides pou kathorizoun den sympiptoun kai epomenos pragmati oi mple kampyles tou erotimatos
# 6 den kathorizoun mia 95% lorida empistosynis gia tin pragmatiki eytheia. 
# simeiosi: an oi mple kampyles eixan xrisimopoiithei gia to skopo ayto, tote tha eixan odigisei se "anti-syntiritikes" lorides, diladi se lorides pou einai 
# pio mikres apo oti tha eprepe na einai.  

##Erotima 9

predict(reg, newdata=data.frame(T12=31), interval="prediction")

# I provlepomeni megisti sygkentrosi tou ozontos gia T12=31 einai 115.471.
# To antistoixo diastima provlepsis einai [71.391, 158.903], pou einai arketa megalo.

plot(T12, maxO3)
abline(reg, col="red")      # sxediazei ap'eytheias tin eytheia ton elaxiston tetragonon

T = seq(from = min(T12), to = max(T12), length.out = 500)

P = predict(reg, newdata=data.frame(T12 = T), interval="confidence", level = 0.95)
matlines(T, P[,-1], lty=2, col=c("blue","blue"))

P = predict(reg, newdata=data.frame(T12 = T), interval="prediction", level = 0.95)
matlines(T, P[,-1], lty=3, col=c("magenta","magenta"))

# Einai fanero oti ta diastimata provlepsis einai poly megalytera apo ta antistoixa diastimata empistosynis,
# alla ayto den prepei na mas ekplissei efoson i fysi tous einai diaforetiki.
# Afenos, ta diastimata provlepsis einai atomika, diladi anaferontai stin provlepsi mias mono paratirisis,
# afeterou ypeiserxetai ena kainourio sfalma, ayto tis epomenis paratirisis.
# Apo tin alli meria ta diastimata empistosynis aforoun tis meses apokriseis kai stirizontai mono sta proyparxonta sfalmata.
# Ara loipon i avevaiotita ton atomikon provlepseon tha einai arketa megalyteri.  

##Erotima 10

T15 = ozone$T15
plot(T15, maxO3)

reg = lm(maxO3~T15) #data=ozone

abline(reg, col="red")

# Kanoume mia apli grammiki palindromisi gia na eksigisoume ti megisti sygkentrosi tou ozontos
# os synartisi tis T15. Paratiroume oti to diagramma diasporas kai i eytheia ton elaxiston tetragonon
# einai paromoia me tin periptosi tis T12, kati to opoio synigorei yper tis apopsis oti ta apotelesmata
# den prepei na einai poly diaforetika. 

summary(reg)

# Par'ola ayta sygkrinontas tis times tou R^2 aytou tou montelou (m2) se sxesi me to arxiko (m1) pou
# eixe os aneksartiti metavliti to T12, vlepoume oti R^2(m1) = 0.2791 < 0.3421 = R^2(m2).
# Ara vlepoyme oti to kainoyrio montelo prosarmozetai kalytera sta dedomena afou o syntelestis
# prosdiorismou tou, pou einai ena metro kalis prosarmogis sta dedomena einai megalyteros gia to m2 
# pou periexei to T15. Tha eixame loipon tin tasi na protimisoume tin T15, xoris vevaia i diafora
# na einai megali, kati pou afinei amfivolies.  

plot(T15, T12)

reg = lm(T12~T15) #data=ozone

abline(reg, col="red")

cor(T12,T15)

# Kanontas to diagramma diasporas tis T12 me tin T15, kai mia grammiki palindromisi tis mias pano stin alli,
# diapistonoume oti oi metavlites aytes einai se megalo vathmo grammika sysxetismenes, kati to opoio
# epivevaionetai kai apo to deigmatiko syntelesti grammikis eksartisis p (eksallou R^2=p^2) 
# Symperainoume oti mia apo tis dyo metavlites arkei gia tin eksigisi tou ozontos (kai oi dyo tha itan peritto)
# kai epilegontas opoiadipote apo tis dyo den tha odigouse se simantikes diafores. Par'ola ayta i T15
# mas odigise se "kalytero" montelo.
   
head(ozone)

# An doume oles tis metavlites pou periexontai sto ozon vlepoume oti yparxoun akoma arketes ypopsifies
# epeksigimatikes metavlites kai etsi ena kalytero symperasma tha mporouse na vgei me mia pollapli grammiki
# palindromisi, pou tha ginei stin epomeni ergasia, oste na kataliksoume sto kalytero dynato montelo.
# Par'ola ayta tha legame sto statistiko, nai men, me ta stoixeia pou exoume mexri tora, fainetai na exeis dikio,
# apo tin alli, gia olous tous logous pou eksigisame, tha prepei na eisai ypomonetikos gia mia pio pliri analysi. 
